/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.hadoop.yarn.csi.client;

import csi.v0.Csi.GetPluginInfoRequest;
import csi.v0.Csi.GetPluginInfoResponse;
import csi.v0.IdentityGrpc;
import io.grpc.stub.StreamObserver;

/**
 * A fake implementation of CSI identity plugin gRPC service.
 * This is for testing purpose only.
 */
public class FakeCsiIdentityService extends IdentityGrpc.IdentityImplBase {

  @Override
  public void getPluginInfo(GetPluginInfoRequest request,
      StreamObserver<GetPluginInfoResponse> responseObserver) {
    GetPluginInfoResponse response = GetPluginInfoResponse.newBuilder()
        .setName("fake-csi-identity-service")
        .setVendorVersion("0.1")
        .build();
    responseObserver.onNext(response);
    responseObserver.onCompleted();
  }
}
